%bcond_with codegen

%global srcname opencensus-proto
%global _description %{expand:
Census provides a framework to define and collect stats against metrics and to
break those stats down across user-defined dimensions.

The Census framework is natively available in many languages (e.g. C++, Go, and
Java). The API interface types are defined using protos to ensure consistency
and interoperability for the different implementations.}

Name:           python-%{srcname}
Version:        0.4.1
Release:    4%{?dist}
Summary:        Language Independent Interface Types For OpenCensus

License:        Apache-2.0
URL:            https://github.com/census-instrumentation/%{srcname}/
Source0:        %{url}/archive/v%{version}/%{srcname}-%{version}.tar.gz

BuildRequires:  python3-devel
%if %{with codegen}
BuildRequires:  %{py3_dist grpcio-tools}
%endif
BuildArch:      noarch

%description %{_description}


%package -n python3-%{srcname}
Summary:        Python library generated from OpenCensus cross-language protos

%description -n python3-%{srcname} %{_description}.


%prep
%autosetup -n %{srcname}-%{version}

%if %{with codegen}
find gen-python/opencensus/proto -type f ! -name '__init__.py' -print -delete
sed -r -i 's|\bpython |%{__python3} |g' src/mkpygen.sh
%endif

sed -r -i 's/^__version__[[:blank:]]*=/# &/' gen-python/version.py
cat >> gen-python/version.py <<EOF
__version__ = '%{version}'  # Correct release version
EOF


%generate_buildrequires
cd gen-python/
%pyproject_buildrequires


%build
%if %{with codegen}
pushd src
./mkpygen.sh
popd
%endif
pushd gen-python/
%pyproject_wheel
popd


%install
pushd gen-python/
%pyproject_install
%pyproject_save_files opencensus
popd


%check


%files -n python3-%{srcname} -f %{pyproject_files}
%license LICENSE
%doc AUTHORS CONTRIBUTING.md gen-python/README.rst

%exclude %{python3_sitelib}/opencensus/{*.py,__pycache__/}


%changelog
* Wed Jun 11 2025 bbrucezhang <bbrucezhang@tencent.com> - 0.4.1-4
- Rebuilt for loongarch64

* Wed Jun 11 2025 bbrucezhang <bbrucezhang@tencent.com> - 0.4.1-3
- Rebuilt for loongarch64

* Wed Jun 11 2025 bbrucezhang <bbrucezhang@tencent.com> - 0.4.1-2
- Rebuilt for loongarch64

* Fri Sep 06 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4.1-1
- initial build
